#include <bits/stdc++.h>

using namespace std;
int n, q, i, d, x[5005];
int pos;
string s;
char c;

template<typename T>
string to_str(const T& n) {
	ostringstream ss;
	ss << n;
	return ss.str();
}
string cut(int pos) {
    return "\"" + s.substr(pos, min((int) s.length() - pos, 15)) + "\"";
}

void stop(int ret, string comment) {
	ofstream out("output.txt");
	out << comment << endl << ret << endl;
	out.close();
	exit(0);
}

bool isEof() {
	return (pos >= s.length());
}
void chk(string ex) {
	if (isEof()) {
		stop(2, "Expected data, but string ended: " + cut(max(0, pos - 15)) + " func: " + ex);
	}
}
char readChar() {
	chk("readChar()");
	return s[pos++];
}
bool readSpace(bool strict = true) {
	chk("readSpace()");
	if (s[pos++] == ' ') {
		return true;
	} else {
		if (strict) {
			stop(2, "Expected space: " + cut(max(0, pos - 5)));
		} else {
			return false;
		}
	}
}
int readInt() {
	int ret = 0;
	bool minus = false;
	chk("readInt()");
	if (s[pos] == '-') {
		minus = true;
		++pos;
	}
	if (!isdigit(s[pos])) {
		stop(2, "Expected number: " + cut(max(0, pos - 5)));
	}
	while (isdigit(s[pos]) && !isEof()) {
		ret = ret * 10 + (s[pos] - '0');
		++pos;
	}
	return (minus ? -ret : ret);
}

void readTest() {
	ifstream in("input.txt");
	in >> n >> q;
	for(int i = 1; i <= n; ++i) {
		in >> x[i];
	}
	in.close();
}
int read(string name, int l, int r, int error = 2) {
	int ret = readInt();
	if (ret < l || ret > r) {
		stop(error, "Expected " + name + " in range [" + to_str(l) + "; " + to_str(r) + "], found " + to_str(ret));
	}
	return ret;
}
string ans(int i, int d) {
	if (x[i] % d == 0) {
		return "Yes";
	} else {
		return "No";
	}
}

int cntEmpty = 0;

int main(int argc, char *argv[]) {
	readTest();
	cout << n << endl;
	cout.flush();
	int cnt = 0;

	while (1) {
		pos = 0;
		getline(cin, s);
		if (isEof()) { /* empty line */
			cntEmpty ++;
			if( cntEmpty > 1e6 )
				stop( 2, "Empty stdin." );
            continue;
		}

		c = readChar();
		readSpace();
		if (c == '?') {
			cnt ++;
			if( cnt > q ) {
				stop(1, "Too many requests: n = " + to_str( n ) + ", "
						"q = " + to_str( q ) + ", "
						"last i = " + to_str(i) + ", d = " + to_str(d) );
			}
            i = read("i", 1, n);
            readSpace();
            d = read("d", 1, 5000);
            cout << ans(i, d) << endl;
            cout.flush();
        } else if (c == '!') {
            for (int i = 1; i < n; ++i) {
                read("x[" + to_str(i) + "]", x[i], x[i], 1);
                readSpace();
            }
            read("x[" + to_str(n) + "]", x[n], x[n], 1);
            while(!isEof()) {
                if (!readSpace(false)) {
                    stop(2, "Extra information after answer: " + cut(pos - 1));
                }
            }
            stop(0, "Okay: n = " + to_str( n ) + ", "
                    "q = " + to_str( q ) + ", "
                    "cnt = " + to_str( cnt ) +
                    " (" + to_str( cnt * 1.0 / n ) + ")");
        } else {
            stop(2, "Expected ? or ! : " + cut(0));
        }
    }
    return 0;
}
